SystemOrganization addCategory: #'A4BP-BPMN20-view'!
SystemOrganization addCategory: 'A4BP-BPMN20-view-Visualization'!

A4BPVCBPProcess subclass: #BPMN20MetricCFCExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20MetricCFCExample methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 2/17/2016 13:23'!
executeMondrianViz: mondrian
	| cv eb values|
	
	"Execute the visulization"
	cv := A4BPUIBVFactory color.
	mondrian interaction action:[ :n | n inspect].
	values := bpObj flowElements.
	mondrian shape rectangle 
		width:[: nn | (nn metricCFC + 1) * 10 ];
		height:[: nn | ( nn metricCFCAbs  + 1 ) * 10 ];
		color:[: nn | (nn accept: cv) alpha:  0.9].
	mondrian nodes: values.
	"Blues, PuBuGn, BuPu, GnBu, YlGn, Greens, YlOrBr, YlOrRd, Greys, Reds, YlGnBu, PuRd, RdPu, PuBu, BuGn, Oranges, Purples, OrRd"
	mondrian normalizer
		normalizeColor: #numberOfRelations 
		using: (ColorPalette sequential colors: 9 scheme: 'YlOrRd') 
		using: #value.
		
	eb := mondrian edges.
	eb shape line color:(Color lightGray).
	eb connectFrom:#yourself toAll:[ :n | n outFlows].
	mondrian layout tree.
	mondrian build.! !

!BPMN20MetricCFCExample methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 2/16/2016 12:31'!
executeVisualization: rtView
	|  cv  lb entities |
	cv := A4BPUIBVFactory color.
	
	"Execute the visulization"
	self executeViz: rtView.
	"Create the legend builder"
	lb := RTLegendBuilder new view: rtView.
	lb addText:'width:metric CFC Abs'.
	lb addText:'height: metric CFC'.
	lb addText:'color number Of Relations'.
	entities := Dictionary new.
	bpObj flowElements do:[ :p | entities at: p class put: p class].
	entities do:[ :p |  lb addColor:(p new accept: cv) text: p bpmn20Name ].
	lb right.
	lb build.
	! !

!BPMN20MetricCFCExample methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 2/16/2016 12:10'!
executeViz: rtView
	| cv eb  values  mondrian|
	
	mondrian := RTMondrian new.
	mondrian view: rtView.
	
	rtView @ RTDraggableView .
	
	"Execute the visulization"
	cv := A4BPUIBVFactory color.
	mondrian interaction action:[ :n | n inspect].
	values := bpObj flowElements.
	mondrian shape rectangle 
		width:[: nn | (nn metricCFC + 1) * 10 ];
		height:[: nn | ( nn metricCFCAbs  + 1 ) * 10 ];
		color:[: nn | (nn accept: cv) alpha:  0.9].
	mondrian nodes: values.
	"Blues, PuBuGn, BuPu, GnBu, YlGn, Greens, YlOrBr, YlOrRd, Greys, Reds, YlGnBu, PuRd, RdPu, PuBu, BuGn, Oranges, Purples, OrRd"
	mondrian normalizer
		normalizeColor: #numberOfRelations 
		using: (ColorPalette sequential colors: 9 scheme: 'YlOrRd') 
		using: #value.
		
	eb := mondrian edges.
	eb shape line color:(Color lightGray).
	eb connectFrom:#yourself toAll:[ :n | n outFlows].
	mondrian layout tree.
	mondrian build.! !

!BPMN20MetricCFCExample methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcamop 6/9/2015 14:54'!
name
	^ 'BPMN20 CFC example'! !

A4BPVCBPProcess subclass: #BPMN20RoleMetricCFCExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20RoleMetricCFCExample methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 2/17/2016 13:54'!
executeVisualization: rtView
	| view model cv eb lb values entities circle|
	view := RTMondrian new.
	view view: rtView.
	rtView @ RTDraggableView .
	model := bpObj.
	
	"Execute the visulization"
	
	cv := A4BPUIBVFactory color.
	view interaction action:[ :n | n inspect].
	values := model lanes.
	view shape rectangle color:[: n | (n accept: cv)].
	view nodes: values forEach:[:nn | 
		"view shape label text: (nn aName size > 0 ifTrue:[ nn aName copyFrom:1 to:4] ifFalse:[nn aName])."
		view shape label text:[:n| n aName].
		view node:nn.
		view shape rectangle 
		width:[: n | n metricCFCAbs * 10];
		height:[: n | ( n numberOfRelations  + 2 ) * 20];
		color:[: n | Color gray alpha: 1 - (1 / (n numberOfRelations + 1) )].
		view node: nn.
		view layout verticalLine.
		].
	
	eb := view edges.
	eb shape line color:(Color lightGray).
	eb connectToAll:#outFlows.
	circle:= view layout circle.
	circle radius: 200.
	view build.
	lb := RTLegendBuilder new view: view view.
	lb addText:'width: metric CFC Absolute'.
	lb addText:'height: metric CFC'.
	lb addText:'color: number Of Relations'.
	entities := Dictionary new.
	values do:[ :p | entities at: p class put: p class].
	entities do:[ :p |  lb addColor:(p new accept: cv) text: p name ].
	lb right.
	lb build.
	! !

!BPMN20RoleMetricCFCExample methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 6/11/2015 16:13'!
name
	^ 'BPMN20 Role CFC example'! !

A4BPVCBPProcess subclass: #BPMN20SimpleCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20SimpleCluster methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 3/15/2015 00:44'!
executeVisualization: view
	| v model c |
	v := RTMondrian new.
	v view: view.
	view @ RTDraggableView .
	model := bpObj.
	c := A4BPUIBPModelColorBuilderVisitor new.
	
	"Execute the visulization"
	
	c:= A4BPUIBVFactory colorVisitor.
	v shape circle size:10;color:[:n|n accept:c].
	v nodes: model elements.
	v edges notUseInLayout;
	connectToAll: [:n|n outFlows].
	v layout cluster.
	v build.! !

A4BPVCBPProcess subclass: #BPMN20StandarVisualization
	instanceVariableNames: 'modifyElementBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20StandarVisualization methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcamop 5/20/2015 15:04'!
executeVisualization: view
	| model cv eb nodes mnodes  vizp shapeNodes|
	view @ RTDraggableView.
	model := bpObj.
	cv:= A4BPUIBVFactory colorVisitor.
	nodes :=  model flowElements.
	vizp:= BPMN20StandarVizPoint new.
	"Start the visualization"
	shapeNodes := nodes select:[:el | el shape isNotNil].
	shapeNodes do: [ :el | 
		| point es|
		point := vizp newp:el.
		es := (RTBox new 
		width: el shape bounds width;
		height: el shape bounds height;
		color:[:n | n accept:cv];
		elementOn: el) 
		translateTo: point.
		es @ RTDraggable @ RTPopup.
		es when: TRMouseClick do: [ :evt | evt element model inspect ].
		modifyElementBlock cull: es.
		view add: es.
	].
	"RTNest new for: view elements add: [ :group :esmodel | 
		group add: ((RTLabel new) elementOn: esmodel aName).
		RTGridLayout on: group.
	]."
	
	eb := RTEdgeBuilder new.
	eb view: view.
	eb shape arrowedLine color: Color black.
	eb objects: nodes from: #yourself toAll: [ :e |  e outFlows].
	
	mnodes := model messageFlows.
	eb objects: mnodes from: [ :e |  e sourceRef] to: [ :e |  e targetRef].
	
	eb notUseInLayout.
	view canvas camera focusOnCenterScaled.! !

!BPMN20StandarVisualization methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcamop 5/20/2015 15:03'!
initialize
	super initialize.
	modifyElementBlock := [:e].! !

!BPMN20StandarVisualization methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/20/2015 15:04'!
modifyElementBlock
	^ modifyElementBlock! !

!BPMN20StandarVisualization methodsFor: 'accessing' stamp: 'AlvaroJosePeraltaOcamop 5/20/2015 15:04'!
modifyElementBlock: anObject
	modifyElementBlock := anObject! !

A4BPVCBPProcess subclass: #BPMN20StandarVisualizationSvg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20StandarVisualizationSvg methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcampo 2/17/2016 13:43'!
executeVisualization: view
	| model cv eb nodes mnodes  svgv vizp | 
	view @ RTDraggableView.
	model := bpObj.
	cv:= A4BPUIBVFactory colorVisitor.
	svgv := BPMN20IconsSvg new.
	
	nodes :=  model flowElements.
	"Start the visualization"	
	vizp:= BPMN20StandarVizPoint new.
	vizp addBasicElement: view.
	
	model lanes do: [ :el |  el shape  ifNotNil: [ 
		| point es rtBox|
		point := vizp newp:el.
		rtBox := (RTBox new 
			width: el shape bounds width;
			height: el shape bounds height;
			color:[:n | n accept:cv];
			borderColor: Color black) .
		es := rtBox elementOn:el.
		es @ RTDraggable @ RTPopup.
		es translateTo: point.
		es @ RTPopup.
		es when: TRMouseClick do: [ :evt | evt element inspect ].
		view add: es.
		] 
	].
			
	nodes do: [ :el | el shape  ifNotNil: [ 
		| point es eslabel|
		point := vizp newp:el.
		"create element on into the svgv visitor, create the element base on svg object"
		es :=  el accept: svgv.
		es color: (el accept:cv).
		eslabel := RTLabel new elementOn:el.
		es translateTo: point.
		eslabel translateTo: point.
		es @ RTDraggable @ RTPopup.
		es when: TRMouseClick do: [ :evt | evt element inspect ].
		view add: es.
		view add: eslabel.
		] 
	].
	
	eb := RTEdgeBuilder new.
	eb notUseInLayout.
	eb view: view.
	eb shape arrowedLine color: Color black.
	(eb objects: nodes )connectFrom:#yourself toAll: [ :e |  e outFlows].
	mnodes := model messageFlows.
	(eb objects: mnodes) connectFrom: [ :e |  e sourceRef] to: [ :e |  e targetRef].
	view canvas camera focusOnCenterScaled.! !

!BPMN20StandarVisualizationSvg methodsFor: 'visualization' stamp: 'AlvaroJosePeraltaOcamop 6/9/2015 14:54'!
name
	^ 'BPMN20 standar view'! !

A4BPVCBPProcess subclass: #BPMN20V
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20V class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/20/2015 14:51'!
standarSvg: aModel view:v
	|svgBuilder|
	svgBuilder := BPMN20StandarVisualizationSvg new.
	svgBuilder bpObj: aModel.
	svgBuilder executeVisualization: v.! !

A4BPUIBPAbstractViewBuilderVisitor subclass: #BPMN20IconsSvg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20IconsSvg class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #BPMN20IconsSvg  super: #A4BPUIBPAbstractViewBuilderVisitor >
<package: #'A4BP-BPMN20-view' >! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 1/11/2016 01:08'!
elementOn: aModel withsvgElement: svg
	|shape label es|
	shape := RTCompositeShape new.
	label := RTLabel new.
	label text: aModel aName.
	shape add: svg.
	shape add: label.
	"svg scale:1."
	es := shape elementOn: aModel.
	^ svg elementOn:aModel.! !

!BPMN20IconsSvg methodsFor: 'basic' stamp: 'AlvaroJosePeraltaOcamop 5/15/2015 15:03'!
visitA4BPObject: aModel
	| p|
	p := 'm 134.28572,129.50507 125.71428,0 c 26.90858,0 48.57143,21.66285 48.57143,48.57143 l 0,45.71428 c 0,26.90858 -21.66285,48.57143 -48.57143,48.57143 l -125.71428,0 c -26.90858,0 -48.571433,-21.66285 -48.571433,-48.57143 l 0,-45.71428 c 0,-26.90858 21.662853,-48.57143 48.571433,-48.57143 z'.
	^  self elementOn: aModel withsvgElement: (RTSVGPath new centeredPath: p; scale: 0.3).! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20ComplexGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcamop 5/15/2015 12:39'!
visitBPMN20EndEventImpl: aModel
	| p scale|
	p := 'm 86.873964,113.25507 21.609226,0 c 36.75139,0 66.33825,29.58687 66.33825,66.33826 l 0,11.60919 c 0,36.7514 -29.58686,66.33826 -66.33825,66.33826 l -21.609226,0 c -36.751394,0 -66.338257,-29.58686 -66.338257,-66.33826 l 0,-11.60919 c 0,-36.75139 29.586863,-66.33826 66.338257,-66.33826 z'.
	scale := aModel shape bounds width / 200.
	^ self elementOn: aModel withsvgElement: (RTSVGPath new centeredPath: p; scale: scale) ! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20EventBasedGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20ExclusiveGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcamop 5/15/2015 12:39'!
visitBPMN20GatewayImpl: aModel
	| p scale|
	p := 'm -68.318504,177.5455 80,0 c 5.54,0 10,4.46 10,10 l 0,80 c 0,5.54 -4.46,10 -10,10 l -80,0 c -5.54,0 -10,-4.46 -10,-10 l 0,-80 c 0,-5.54 4.46,-10 10,-10 z'.
	"scale := aModel shape bounds width / 100."
	scale := 0.3.
	^ self elementOn: aModel withsvgElement: (RTSVGPath new centeredPath: p; scale: scale ; rotate:45).! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:42'!
visitBPMN20InclusiveGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 1/11/2016 00:53'!
visitBPMN20IntermediateThrowEventImpl: aModel
	| p scale|
	p := 'm 134.28572,129.50507 125.71428,0 c 26.90858,0 48.57143,21.66285 48.57143,48.57143 l 0,45.71428 c 0,26.90858 -21.66285,48.57143 -48.57143,48.57143 l -125.71428,0 c -26.90858,0 -48.571433,-21.66285 -48.571433,-48.57143 l 0,-45.71428 c 0,-26.90858 21.662853,-48.57143 48.571433,-48.57143 z'.
	scale := aModel shape bounds width / 400.
	^  self elementOn: aModel withsvgElement: (RTSVGPath new centeredPath: p; scale: scale).! !

!BPMN20IconsSvg methodsFor: 'gateways' stamp: 'AlvaroJosePeraltaOcampo 3/25/2015 09:43'!
visitBPMN20ParallelGatewayImpl: aModel
	^ self visitBPMN20GatewayImpl: aModel! !

!BPMN20IconsSvg methodsFor: 'events' stamp: 'AlvaroJosePeraltaOcampo 1/11/2016 00:53'!
visitBPMN20StartEventImpl: aModel
	| p scale|
	p := 'm 86.873964,113.25507 21.609226,0 c 36.75139,0 66.33825,29.58687 66.33825,66.33826 l 0,11.60919 c 0,36.7514 -29.58686,66.33826 -66.33825,66.33826 l -21.609226,0 c -36.751394,0 -66.338257,-29.58686 -66.338257,-66.33826 l 0,-11.60919 c 0,-36.75139 29.586863,-66.33826 66.338257,-66.33826 z'.
	scale := aModel shape bounds width / 200.
	^ self elementOn: aModel withsvgElement: (RTSVGPath new centeredPath: p; scale: scale).! !

!BPMN20IconsSvg methodsFor: 'activities' stamp: 'AlvaroJosePeraltaOcampo 1/11/2016 00:53'!
visitBPMN20TaskImpl: aModel
	| p scale|
	p := 'm 134.28572,129.50507 125.71428,0 c 26.90858,0 48.57143,21.66285 48.57143,48.57143 l 0,45.71428 c 0,26.90858 -21.66285,48.57143 -48.57143,48.57143 l -125.71428,0 c -26.90858,0 -48.571433,-21.66285 -48.571433,-48.57143 l 0,-45.71428 c 0,-26.90858 21.662853,-48.57143 48.571433,-48.57143 z'.
	"scale := aModel shape bounds width / 400."
	scale := 0.3.
	^  self elementOn: aModel withsvgElement: (RTSVGPath new centeredPath: p; scale: scale).! !

Object subclass: #BPMN20StandarVizPoint
	instanceVariableNames: 'ww hh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20StandarVizPoint methodsFor: 'initalize' stamp: 'AlvaroJosePeraltaOcampo 2/17/2016 13:40'!
addBasicElement: view
	|box|
	box := RTBox new width: ww ;height: hh ; color: (Color lightGray alpha:0.1); elementOn:''.
	box @ RTDraggable @ RTPopup.
	box translateTo:0@0.
	view add: box.! !

!BPMN20StandarVizPoint methodsFor: 'initalize' stamp: 'AlvaroJosePeraltaOcampo 2/16/2016 11:54'!
initialize
	super initialize.
	ww:= 0.
	hh:= 0.
	! !

!BPMN20StandarVizPoint methodsFor: 'initalize' stamp: 'AlvaroJosePeraltaOcampo 3/27/2015 18:56'!
newp: el
	|point w h x y|
	w := el shape bounds width.
	h :=  el shape bounds height.
	x := el shape bounds x.
	y := el shape bounds y.
	point := ( (w/2) - ( ww / 2 ) + x ) @ ( (h) - (hh/2)- (h/2) + y ).
	^ point! !

!A4BPVCBuilder methodsFor: '*A4BP-BPMN20-view-Visualization' stamp: 'AlvaroJosePeraltaOcamop 5/13/2015 16:12'!
visitBPMN20Object: aModel
	| visualizations builder|
	visualizations := OrderedCollection new.
	builder := BPMN20VCBuilder new.
	visualizations addAll: (aModel accept: builder).
	^ visualizations! !

A4BPVCBuilder subclass: #BPMN20VCBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-BPMN20-view-Visualization'!

!BPMN20VCBuilder class methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 4/24/2015 14:20'!
annotation
<MSEClass: #BPMN20VCBuilder  super: #A4BPVCBuilder >
<package: #'A4BP-BpelAnalyze-View' >! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 6/11/2015 16:06'!
addViz: aClass inList: visualizations withModel: aModel
	visualizations add: (aClass new bpObj: aModel).
	^ visualizations! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 6/11/2015 16:08'!
visitBPMN20DefinitionsImpl: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	"Stantard visualization"
	self setVisualizationForAllModel: visualizations inModel: aModel.
	self addViz: BPMN20StandarVisualizationSvg inList: visualizations withModel: aModel.
	"Metric example CFC"
	self addViz: BPMN20MetricCFCExample inList: visualizations withModel: aModel.
	self addViz: BPMN20RoleMetricCFCExample inList: visualizations withModel: aModel.
	^ visualizations! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/19/2015 12:49'!
visitBPMN20Object: aModel
	| visualizations |
	visualizations := OrderedCollection new.
	^ visualizations! !

!BPMN20VCBuilder methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 6/11/2015 16:06'!
visitBPMN20ProcessImpl: aModel
	| visualizations|
	visualizations := OrderedCollection new.
	self addViz: BPMN20SimpleCluster inList: visualizations withModel: aModel.
	self addViz: BPMN20StandarVisualizationSvg inList: visualizations withModel: aModel.
	^ visualizations! !
